/**
  **************************************************************************
  * @file     at32_video_ev_bf3901.h
  * @version  v2.0.2
  * @date     2022-09-15
  * @brief    at32_video_ev_bf3901 header file
  **************************************************************************
  *                       Copyright notice & Disclaimer
  *
  * The software Board Support Package (BSP) that is made available to
  * download from Artery official website is the copyrighted work of Artery.
  * Artery authorizes customers to use, copy, and distribute the BSP
  * software and its related documentation for the purpose of design and
  * development in conjunction with Artery microcontrollers. Use of the
  * software is governed by this copyright notice and the following disclaimer.
  *
  * THIS SOFTWARE IS PROVIDED ON "AS IS" BASIS WITHOUT WARRANTIES,
  * GUARANTEES OR REPRESENTATIONS OF ANY KIND. ARTERY EXPRESSLY DISCLAIMS,
  * TO THE FULLEST EXTENT PERMITTED BY LAW, ALL EXPRESS, IMPLIED OR
  * STATUTORY OR OTHER WARRANTIES, GUARANTEES OR REPRESENTATIONS,
  * INCLUDING BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.
  *
  **************************************************************************
  */

#ifndef __AT32_VIDEO_EV_BF3901_H
#define __AT32_VIDEO_EV_BF3901_H
#include "at32f403a_407_board.h"
#include "at32_video_ev_sccb.h"
#include "at32_video_ev_spi.h"

#define  BF3901_PWDN_GPIO				         GPIOB
#define  BF3901_PWDN_GPIO_CLK			       CRM_GPIOB_PERIPH_CLOCK
#define  BF3901_PWDN_PIN                 GPIO_PINS_10

#define FRAME_START_CODE 		             0xb6
#define FRAME_END_CODE 		               0xb9
#define LINE_START_CODE 		             0x8a
#define LINE_PACKET_CODE 		             0x9d
#define HEAD_SYNC_CODE1 		             0xff
#define HEAD_SYNC_CODE2 		             0x00
#define HEAD_SYNC_CODE3 		             0x00

#define RX_IDLE_FLG 					           0x00

#define FRAME_START_SYNC1_FLG 		       0xF1
#define FRAME_START_SYNC2_FLG 		       0xF2
#define FRAME_START_SYNC3_FLG 		       0xF3

#define FRAME_START_SYNC_FLG 	           0xF1
#define FRAME_START_FLG 				         0xF4

#define DATA_ID_L_FLG 			             0xE1
#define DATA_ID_FLG 			               0xE2
#define IMAGE_W_L_FLG 		               0xE3
#define IMAGE_W_H_FLG 		               0xE4
#define IMAGE_H_L_FLG 			             0xE5
#define IMAGE_H_H_FLG 		               0xE6

#define LINE_START_SYNC1_FLG 	           0xA1
#define LINE_START_SYNC2_FLG 	           0xA2
#define LINE_START_SYNC3_FLG 	           0xA3
#define LINE_START_FLG 			             0xA4
#define LineNum_L_FLG 			             0xA5
#define LineNum_H_FLG 			             0xA6

#define LINE_PACKET_SYNC1_FLG 	         0x91
#define LINE_PACKET_SYNC2_FLG 	         0x92
#define LINE_PACKET_SYNC3_FLG 	         0x93
#define LINE_PACKET_FLG 		             0x94
#define PACKET_SIZE_L_FLG 		           0x95
#define PACKET_SIZE_H_FLG 		           0x96
#define PACKET_RX_FLG 			             0x97

#define FRAME_END_SYNC1_FLG 	           0x81
#define FRAME_END_SYNC2_FLG 	           0x82
#define FRAME_END_SYNC3_FLG 	           0x83
#define FRAME_END_FLG 		               0x84

void bf3901_pwdn_pin_init(void);
void bf3901_pwdn_pin_op(void);
void bf3901_pwdn_pin_op1(void);
u8   bf3901_init(void);
void bf3901_light_mode(u8 mode);
void bf3901_color_saturation(u8 sat);
void bf3901_brightness(u8 bright);
void bf3901_contrast(u8 contrast);
void bf3901_special_effects(u8 eft);
void bf3901_window_set(u16 sx, u16 sy, u16 width, u16 height);
void bf3901_iicwriteonebyte(u8 u8writeaddr, u8 u8datatowrite);

#endif
