/**
  **************************************************************************
  * @file     at32_video_ev_malloc.h
  * @version  v2.0.2
  * @date     2022-09-15
  * @brief    at32_video_ev_malloc header file
  **************************************************************************
  *                       Copyright notice & Disclaimer
  *
  * The software Board Support Package (BSP) that is made available to
  * download from Artery official website is the copyrighted work of Artery.
  * Artery authorizes customers to use, copy, and distribute the BSP
  * software and its related documentation for the purpose of design and
  * development in conjunction with Artery microcontrollers. Use of the
  * software is governed by this copyright notice and the following disclaimer.
  *
  * THIS SOFTWARE IS PROVIDED ON "AS IS" BASIS WITHOUT WARRANTIES,
  * GUARANTEES OR REPRESENTATIONS OF ANY KIND. ARTERY EXPRESSLY DISCLAIMS,
  * TO THE FULLEST EXTENT PERMITTED BY LAW, ALL EXPRESS, IMPLIED OR
  * STATUTORY OR OTHER WARRANTIES, GUARANTEES OR REPRESENTATIONS,
  * INCLUDING BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.
  *
  **************************************************************************
  */

#ifndef __AT32_VIDEO_EV_MALLOC_H
#define __AT32_VIDEO_EV_MALLOC_H
#include "at32f403a_407.h" 

#ifndef NULL
#define NULL 0
#endif

#define SRAMIN	 0


#define SRAMBANK 	1	//number of sram bank


#define MEM1_BLOCK_SIZE			32  
#define MEM1_MAX_SIZE			100*1024  	
#define MEM1_ALLOC_TABLE_SIZE	MEM1_MAX_SIZE/MEM1_BLOCK_SIZE 

struct _m_mallco_dev
{
	void (*init)(u8);					
	u8 (*perused)(u8);		  	
	u8 	*membase[SRAMBANK];		
	u16 *memmap[SRAMBANK]; 		
	u8  memrdy[SRAMBANK]; 		
};
extern struct _m_mallco_dev mallco_dev;	

/* internal use */
void mymemset(void *s,u8 c,u32 count);	 
void mymemcpy(void *des,void *src,u32 n);
void my_mem_init(u8 memx);				       
u32 my_mem_malloc(u8 memx,u32 size);	   
u8 my_mem_free(u8 memx,u32 offset);		   
u8 my_mem_perused(u8 memx);				       

/* for user */
void myfree(u8 memx,void *ptr);  	
void *mymalloc(u8 memx,u32 size);	
void *myrealloc(u8 memx,void *ptr,u32 size);
#endif
